
/* menu.c implement a simple menu using conio */

#define USE_OEM_CHARS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include "menu.h"
#include <conio.h>

#define BANNER "Faked Dos 6.22 Configuration Menu"
#define UNDERBAR 0xCD

int my_return(int);  /* allows to do some cleanup */
/* colors to leave screen in when we leave the menu */
#define RESTORE_BACKGROUND 1 
#define RESTORE_FOREGROUND 15

#define UP 0x4800
#define DOWN 0x5000

int menu_text(struct menuitem_struct **my_menu, int nmenuitems,
        int menudefault,int menutimeout,int menuforeground,int menubackground)
{
        int i;
        int choice;
        int c;
        int key;


        textbackground(menubackground);
	textcolor(menuforeground);
        clrscr();
	cprintf("%s\r\n",BANNER);
	for(i=0;i<strlen(BANNER);i++)putch(UNDERBAR);
	cprintf("\r\n\r\n");

        choice = menudefault;

        for(i=0;i<nmenuitems;i++){
               if(i + 1 == menudefault){
                        textcolor(menubackground+BLINK);
                        textbackground(menuforeground);
               }
               else {
                        textcolor(menuforeground);
                        textbackground(menubackground);
               }
               cprintf("%d. %s\r\n\r\n",i+1,(my_menu[i])->text);
        }
        textcolor(menuforeground);
        textbackground(menubackground);
        if(menutimeout > 0)
        cprintf("     Select from menu [1-%d] or hit return (Selection = %d ) - %2d",
                nmenuitems,menudefault,menutimeout);
        else
        cprintf("     Select from menu [1-%d] or hit return (Selection = %d )",
                nmenuitems,menudefault);

        /* Polling loop */
        i = 0;
        while(1){
                i++;  /* count tenths of a second */
                delay(100);
                if(bioskey(1))break;
                if(menutimeout > 0){
                        if(!(i%10))
                                cprintf("\b\b%2d",menutimeout - i/10);
                        if(i/10 > menutimeout)return my_return(menudefault);
                }
        }
        key = bioskey(0);
        c = key & 0xFF;
        if((c == '\n')||(c == '\r'))
                return my_return(menudefault);
        choice = (int)(c - '0');
        if((choice > 0)&&(choice <= nmenuitems))return my_return(choice);
        if(key == UP)
                if(menudefault > 1)menudefault--;
        if(key == DOWN)
                if(menudefault < nmenuitems)menudefault++;
        while(1){
                clrscr();
		cprintf("%s\r\n",BANNER);
		for(i=0;i<strlen(BANNER);i++)putch(UNDERBAR);
		cprintf("\r\n\r\n");
                for(i=0;i<nmenuitems;i++){
                        if(i + 1 == menudefault){
                         textcolor(menubackground+BLINK);
                         textbackground(menuforeground);
                        }
                        else {
                                textcolor(menuforeground);
                                textbackground(menubackground);
                        }
                        cprintf("%d. %s\r\n\r\n",i+1,(my_menu[i])->text);
                }
                textcolor(menuforeground);
                textbackground(menubackground);
                cprintf("     Select from menu [1-%d] or hit return (Selection = %d)",
                nmenuitems,menudefault);
                while(bioskey(1)==0) delay(100);
                key = bioskey(0);
                c = key & 0xFF;
                if((c == '\n')||(c == '\r'))
                return my_return(menudefault);
                choice = (int)(c - '0');
                if((choice > 0)&&(choice <= nmenuitems))return my_return(choice);
                if(key == UP)
                        if(menudefault > 1)menudefault--;
                if(key == DOWN)
                        if(menudefault < nmenuitems)menudefault++;
                
        }

}

int my_return(int r)
{
        textbackground(RESTORE_BACKGROUND);
        textcolor(RESTORE_FOREGROUND);
        clrscr();
        return r;
}
struct menuitem_struct *alloc_menuitem(void)
{
        return (struct menuitem_struct *)malloc(sizeof(struct menuitem_struct));
}
